#include <stdlib.h>
#include <string.h>

#include "channel.h"

unsigned char *
channel_dup(unsigned char *pixels, int size)
{
    unsigned char *result = malloc(size*sizeof(unsigned char));

    memcpy(pixels, result, size*sizeof(unsigned char));
    return result;
}    

unsigned char *
channel_extract(unsigned char *pixels, int size, int channel_number)
{
    unsigned char *channel = malloc(size*sizeof(unsigned char));

    unsigned char *src = pixels + channel_number;
    unsigned char *dst = channel;

    for (int i = size; i > 0; i--, src += 3, dst ++)
	*dst = *src;

    return channel;
}

unsigned char *
channel_compose(unsigned char *r_chan,
		unsigned char *g_chan,
		unsigned char *b_chan,
		size_t size)
{
    unsigned char *result = malloc(3*size*sizeof(unsigned char));
    unsigned char *dst = result;
    
    for (int i = size; i > 0; i--)
    {
	*dst++ = *r_chan++;
	*dst++ = *g_chan++;
	*dst++ = *b_chan++;
    }	

    return result;
}
